/******************************************************************************
*
* project name:   TICT Tutorial S2P1
* file name:      genlookup.c
* initial date:   21/02/2001  (TiCT's first Anniversary ;-)
* author:         thomas.nussbaumer@gmx.net
*
* description:    Generates lookup table for vertical texture scaling
*
* NOTE: this program should be compilable with any ANSI C compiler
*
* $Id: genlookup.c,v 1.1 2001/02/22 19:58:54 Thomas Nussbaumer Exp $
*
******************************************************************************/
#include <stdio.h>
#include <math.h>

#define SIZE_OF_TEXTURE            64
#define BYTES_PER_LINE_IN_TEXTURE (SIZE_OF_TEXTURE/8)

//----------------------------------------------------------------------------
// NOTE: the generated values are byte offsets (delta values) from the actual
//       address of the actual pixel to the adress of the next pixel
//       within the texture
//----------------------------------------------------------------------------
void GenerateTable(void) {
     short           i,j;
     double          delta;
     unsigned short  value;
     unsigned short  prev_val;

     for (i=0;i<SIZE_OF_TEXTURE;i++) {
         delta    = ((double)SIZE_OF_TEXTURE)/(double)(i+1);
         prev_val = 0;

         printf("(unsigned short [%d]){",i+1);
         for (j=0;j<i+1;j++) {
             unsigned short tmp;
             value = (unsigned short)floor(j*delta+0.5);
             if (value > SIZE_OF_TEXTURE-1) value = SIZE_OF_TEXTURE-1;
             value *= BYTES_PER_LINE_IN_TEXTURE;
             tmp    = value;
             value -= prev_val;
             prev_val = tmp;

             printf("%u",value);
             if (j<i) fputc(',',stdout);
         }

         fputc('}',stdout);
         if (i<SIZE_OF_TEXTURE-1) fputc(',',stdout);
         fputc('\n',stdout);
    }
}


//----------------------------------------------------------------------------
// just a simple main ...
//----------------------------------------------------------------------------
int main(int argc,char* argv[]) {
    printf("unsigned short** lookup_table = (unsigned short *[%d]){\n",SIZE_OF_TEXTURE);
    GenerateTable();
    printf("};\n");
    return 0;
}


//#############################################################################
// Revision History
//#############################################################################
//
// $Log: genlookup.c,v $
// Revision 1.1  2001/02/22 19:58:54  Thomas Nussbaumer
// initial version
//
//
//
//
